SystemOrganization addCategory: #Meta!

Object subclass: #UtilidadDeComposicion
	instanceVariableNames: ''
	classVariableNames: 'utilidadDeComposicion'
	poolDictionaries: ''
	category: 'Meta'!

!UtilidadDeComposicion class methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 13:52'!
new
	utilidadDeComposicion	ifNil:[utilidadDeComposicion := super new].
	^utilidadDeComposicion.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 16:52'!
agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: unaClaseComposicion

	metodosRedefinidos do: [:metodoRedefinido | 
		unaClaseComposicion methodDictionary at: metodoRedefinido put: (unaClase methodDictionary at: metodoRedefinido).
		unaClase removeSelector: metodoRedefinido.].! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 16:53'!
algunasSubclasesDe: unaClase Redefinen: unMetodo

	^(unaClase subclasses anySatisfy:  [: unaSubclase | unaSubclase methodDictionary keys includes: unMetodo]).! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 23:12'!
cambiarHerenciaPorComposicion: unaClase conElNombre: nombreComposicion

	|metodosRedefinidos claseComposicion nombreComposicionProcesado|
	
	(unaClase allSubclasses size = 0) ifTrue: [ ^false ].
	
	metodosRedefinidos := self metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase.
	
	claseComposicion := self crearClaseComposicionAPartirDe: unaClase conElNombre: nombreComposicion.
	
	self agregarMetodosRedefinidos: metodosRedefinidos DeLaClase: unaClase aLaComposicion: claseComposicion. 		
	self hacerHeredarSubclasesDe: unaClase De: claseComposicion. 
	
	nombreComposicionProcesado := (nombreComposicion,'Composicion') asLegalSelector.
	
	unaClase addInstVarNamed:  nombreComposicionProcesado.
	
	self crearAccesorsPara: nombreComposicionProcesado De: unaClase.	
	
	self reemplazarLlamadasAMetodos: metodosRedefinidos En: unaClase Por: nombreComposicionProcesado.
	
	^claseComposicion.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 13:31'!
crearAccesorsPara: unAtributo De: unaClase
	unaClase compile: unAtributo,': ',unAtributo,'Atributo
	',unAtributo,' := ',unAtributo,'Atributo.'.
unaClase compile: unAtributo,'
	^',unAtributo,'.'.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 15:52'!
crearClaseComposicionAPartirDe: unaClase conElNombre: nombreComposicion 

	^
	Object subclass: (nombreComposicion,'Composicion') asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: unaClase category.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/1/2013 19:58'!
hacerHeredarSubclasesDe: unaClase De: claseComposicion
	
	unaClase subclasses do: [:subclase | claseComposicion subclass: (subclase name asSymbol)
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: subclase category].! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 18:15'!
metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: unaClase
	|metodos nombreComposicion|
			
	metodos := unaClase methodDictionary keys.
	
	^metodos select: [ :unMetodo | self algunasSubclasesDe: unaClase Redefinen: unMetodo].
	
	
	! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 23:23'!
reemplazarLlamadasAMetodos: metodosEliminados De: unMetodoCodigo Por: nombreComposicionProcesado
	
	|metodoCodigo metodoEliminadoProcesado|
	
	metodoCodigo := unMetodoCodigo.

	metodosEliminados do: [:metodoEliminado |
		 metodoEliminadoProcesado := ('\w+' asRegex matchesIn: metodoEliminado) at: 1.
		 metodoCodigo := metodoCodigo copyWithRegex: metodoEliminadoProcesado matchesReplacedWith: (nombreComposicionProcesado,' ',metodoEliminadoProcesado)].
	
	^metodoCodigo.! !

!UtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 23:20'!
reemplazarLlamadasAMetodos: metodosEliminados En: unaClase Por: atributoComposicion

	(unaClase methodDictionary values) do: [:metodoRestante | unaClase compile: 
		(self reemplazarLlamadasAMetodos: metodosEliminados De: (metodoRestante getSource) Por: atributoComposicion)].! !

TestCase subclass: #TestUtilidadDeComposicion
	instanceVariableNames: 'claseAbstracta subClase1 subClase2 subClase3 utilidadComposicion claseComposicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta'!

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 16:53'!
claseAbstracta
	^ claseAbstracta! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 16:53'!
claseAbstracta: anObject
	claseAbstracta := anObject! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/3/2013 20:31'!
claseComposicion
	^ claseComposicion! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/3/2013 20:31'!
claseComposicion: anObject
	claseComposicion := anObject! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/2/2013 17:56'!
setUp
	self claseAbstracta: (Object subclass: #ClaseAbstracta instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase1: (self claseAbstracta subclass: #SubClase1 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase2: (self claseAbstracta subclass: #SubClase2 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self subclase3: (self claseAbstracta subclass: #SubClase3 instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	
	self utilidadComposicion: UtilidadDeComposicion new.

! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:24'!
subclase1
	^ subClase1! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:24'!
subclase1: anObject
	subClase1 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase2
	^ subClase2! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase2: anObject
	subClase2 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase3
	^ subClase3! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:25'!
subclase3: anObject
	subClase3 := anObject! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 20:37'!
tearDown 
	self claseAbstracta removeFromSystem.
	self subclase1 removeFromSystem.
	self subclase2 removeFromSystem.
	self subclase3 removeFromSystem.
	self claseComposicion ifNotNil: [self claseComposicion removeFromSystem].! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 20:33'!
testAgregarMetodosRedefinidosALaClaseDeComposicion
	|metodosRedefinidos|
		
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo1 "Codigo metodo1 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo3 "Codigo metodo3 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo1 "Codigo metodo1 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	metodosRedefinidos := self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta.
	
	self claseComposicion: (self utilidadComposicion crearClaseComposicionAPartirDe: self claseAbstracta  conElNombre: 'Composicion').
	
	self utilidadComposicion agregarMetodosRedefinidos: metodosRedefinidos  DeLaClase: self claseAbstracta aLaComposicion: self claseComposicion.
	
	self assert: (self claseComposicion methodDictionary size = 2).
	self assert: ((self claseComposicion methodDictionary at: #metodo1) getSource = 'metodo1 "Codigo metodo1 claseAbstracta"').
	self assert: ((self claseComposicion methodDictionary at: #metodo3) getSource = 'metodo3 "Codigo metodo3 claseAbstracta"').
	
	self claseComposicion removeFromSystem.
	
	self assert: (self claseAbstracta methodDictionary size = 3).
	self assert: ((self claseAbstracta methodDictionary at: #metodo2) getSource = 'metodo2 "Codigo metodo2 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo4) getSource = 'metodo4 "Codigo metodo4 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo5) getSource = 'metodo5 "Codigo metodo5 claseAbstracta"').
	
	
! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 20:34'!
testAgregarMetodosRedefinidosVaciosALaClaseDeComposicion
	|metodosRedefinidos|
		
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo10 "Codigo metodo10 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo9 "Codigo metodo9 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo10 "Codigo metodo10 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	metodosRedefinidos := self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta.
	
	self claseComposicion: (self utilidadComposicion crearClaseComposicionAPartirDe: self claseAbstracta  conElNombre: 'Composicion').
	
	self utilidadComposicion agregarMetodosRedefinidos: metodosRedefinidos  DeLaClase: self claseAbstracta aLaComposicion: self claseComposicion.
	
	self assert: (self claseComposicion methodDictionary size = 0).
	
	self claseComposicion removeFromSystem.
	
	self assert: (self claseAbstracta methodDictionary size = 5).
	self assert: ((self claseAbstracta methodDictionary at: #metodo1) getSource = 'metodo1 "Codigo metodo1 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo2) getSource = 'metodo2 "Codigo metodo2 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo3) getSource = 'metodo3 "Codigo metodo3 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo4) getSource = 'metodo4 "Codigo metodo4 claseAbstracta"').
	self assert: ((self claseAbstracta methodDictionary at: #metodo5) getSource = 'metodo5 "Codigo metodo5 claseAbstracta"').
	
	
! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 23:03'!
testCambioHerenciaPorComposicion
	self claseAbstracta compile: 
		'metodo1Con: parametro1 Y: parametro2 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2Con: parametro1 Y: parametro2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3Con: parametro1 Y: parametro2 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4Con: parametro1 Y: parametro2 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5Con: parametro1 Y: parametro2 
		|p1 p2|
		self metodo9Con: p1 Y: p2
		self metodo3Con: p1 Y: p2 
		"Codigo metodo5 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo9Con: parametro1 Y: parametro2 
		|p1 p2|
		self metodo5Con: p1 Y: p2
		self metodo2Con: p1 Y: p2 
		"Codigo metodo9 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo1Con: parametro1 Y: parametro2 "Codigo metodo1 subClase1"'.
		
	self subclase1 compile: 
		'metodo3Con: parametro1 Y: parametro2 "Codigo metodo3 subClase1"'.
		
	self subclase1 compile: 
		'metodo6Con: parametro1 Y: parametro2 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo2Con: parametro1 Y: parametro2 "Codigo metodo2 subClase2"'.
		
	self subclase2 compile: 
		'metodo7Con: parametro1 Y: parametro2 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo4Con: parametro1 Y: parametro2 "Codigo metodo4 subClase3"'.
		
	self subclase3 compile: 
		'metodo8Con: parametro1 Y: parametro2 "Codigo metodo8 subClase3"'.

	self claseComposicion: (self utilidadComposicion cambiarHerenciaPorComposicion: self claseAbstracta conElNombre: 'Test').
	
	self assert: self claseComposicion name = 'TestComposicion'.
		
	self assert: self claseAbstracta  subclasses size = 0.
		
	self assert: (
		(self claseComposicion subclasses includes: self subclase1) &
		(self claseComposicion subclasses includes: self subclase2) &
		(self claseComposicion subclasses includes: self subclase3) &
		(self claseComposicion subclasses size = 3)
	).
	
	self assert: self claseComposicion methodDictionary size = 4.
	
	self assert: (self claseComposicion methodDictionary at: #metodo1Con:Y:) getSource =	
		'metodo1Con: parametro1 Y: parametro2 "Codigo metodo1 claseAbstracta"'.
		
	self assert: (self claseComposicion methodDictionary at: #metodo2Con:Y:) getSource =	
		'metodo2Con: parametro1 Y: parametro2 "Codigo metodo2 claseAbstracta"'.
		
	self assert: (self claseComposicion methodDictionary at: #metodo3Con:Y:) getSource =	
		'metodo3Con: parametro1 Y: parametro2 "Codigo metodo3 claseAbstracta"'.
		
	self assert: (self claseComposicion methodDictionary at: #metodo4Con:Y:) getSource =	
		'metodo4Con: parametro1 Y: parametro2 "Codigo metodo4 claseAbstracta"'.
	
	self assert: self claseAbstracta methodDictionary size = 4.
	
	self assert: (self claseAbstracta methodDictionary at: #metodo5Con:Y:) getSource =	
		'metodo5Con: parametro1 Y: parametro2 
		|p1 p2|
		self metodo9Con: p1 Y: p2
		self testComposicion metodo3Con: p1 Y: p2 
		"Codigo metodo5 claseAbstracta"'.
		
	self assert: (self claseComposicion methodDictionary at: #metodo4Con:Y:) getSource =	
		'metodo4Con: parametro1 Y: parametro2 "Codigo metodo4 claseAbstracta"'.
	
	self assert: (self claseAbstracta instVarNames includes: 'testComposicion').
	
	self assert: (self claseAbstracta methodDictionary at:#testComposicion) getSource = 'testComposicion
	^testComposicion.'.
	
	self assert: (self claseAbstracta methodDictionary at:#testComposicion:) getSource = 'testComposicion: testComposicionAtributo
	testComposicion := testComposicionAtributo.'.	! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 12:53'!
testClaseAbstractaSinSubclases
	|claseAbstractaPrueba resultado|
	claseAbstractaPrueba := (Object subclass: #ClaseAbstractaPrueba instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Meta').
	resultado := (self utilidadComposicion cambiarHerenciaPorComposicion: claseAbstractaPrueba conElNombre: 'Compo') not.
	claseAbstractaPrueba removeFromSystem.
	self assert: resultado.
	! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 20:14'!
testConMetodosRedefinidos
	|metodosRedefinidos metodosRedefinidosAComparar|

	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo1 "Codigo metodo1 subClase1"'.
		
	self subclase1 compile: 
		'metodo3 "Codigo metodo3 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo2 "Codigo metodo2 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo4 "Codigo metodo4 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.
		
	metodosRedefinidos := self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta.
	metodosRedefinidosAComparar := OrderedCollection new.
	metodosRedefinidosAComparar add: #metodo1; add: #metodo2;add: #metodo3;add: #metodo4.
		
	self assert: (metodosRedefinidos allSatisfy: [:metodoRedefinido | metodosRedefinidosAComparar includes: metodoRedefinido]) & (metodosRedefinidos size = metodosRedefinidosAComparar size).! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 23:25'!
testReemplazarLlamadasAMetodosEliminados
	|codigoFuente codigoFuenteModificado|
	
	codigoFuente := 
		'metodoEjemploDeCodigoCon: fuerzas Y: masa
			|resultante aceleracion|
			
			resultante := fuerzas inject: resultante into: [:resul :fuerza | resul sumar: resul con: fuerza].
			
			aceleracion := resultante escalar: resultante con: (1/masa)
			
			^aceleracion'.
			
	codigoFuenteModificado := self utilidadComposicion reemplazarLlamadasAMetodos: #(#sumar:con: #escalar:con:) De: codigoFuente Por:'composicion'.
	
	self assert: (codigoFuenteModificado = 
	 'metodoEjemploDeCodigoCon: fuerzas Y: masa
			|resultante aceleracion|
			
			resultante := fuerzas inject: resultante into: [:resul :fuerza | resul composicion sumar: resul con: fuerza].
			
			aceleracion := resultante composicion escalar: resultante con: (1/masa)
			
			^aceleracion').
			
	codigoFuenteModificado := self utilidadComposicion reemplazarLlamadasAMetodos: #() De: codigoFuente Por:'composicion'.

	self assert: (codigoFuenteModificado = codigoFuente).
	! !

!TestUtilidadDeComposicion methodsFor: 'as yet unclassified' stamp: 'Edu 5/3/2013 10:05'!
testSinMetodosRedefinidos
	self claseAbstracta compile: 
		'metodo1 "Codigo metodo1 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo2 "Codigo metodo2 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo3 "Codigo metodo3 claseAbstracta"'.
	
	self claseAbstracta compile: 
		'metodo4 "Codigo metodo4 claseAbstracta"'.
		
	self claseAbstracta compile: 
		'metodo5 "Codigo metodo5 claseAbstracta"'.
	
	self subclase1 compile: 
		'metodo9 "Codigo metodo9 subClase1"'.
		
	self subclase1 compile: 
		'metodo8 "Codigo metodo8 subClase1"'.
		
	self subclase1 compile: 
		'metodo6 "Codigo metodo6 subClase1"'.

	self subclase2 compile: 
		'metodo8 "Codigo metodo8 subClase2"'.
		
	self subclase2 compile: 
		'metodo7 "Codigo metodo7 subClase2"'.

	self subclase3 compile: 
		'metodo9 "Codigo metodo9 subClase3"'.
		
	self subclase3 compile: 
		'metodo8 "Codigo metodo8 subClase3"'.

	self assert: (self utilidadComposicion metodosRedefinidosPorAlgunasDeTodasLasSubclasesDe: self claseAbstracta) = #().   ! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:56'!
utilidadComposicion
	^ utilidadComposicion! !

!TestUtilidadDeComposicion methodsFor: 'accessing' stamp: 'Edu 5/2/2013 17:56'!
utilidadComposicion: anObject
	utilidadComposicion := anObject! !
